using System;
using System.IO;
using setPoint.messageReifying;
using setPoint.weaving;

namespace LENDLConfiguration {
	/// <summary>
	/// Summary description for LoggingAspect.
	/// </summary>
	public class LoggingAspect : IAspect {
		private DateTime _startTime;		

		public LoggingAspect() {
		}

		public void startLogging(IJoinPoint aJoinpoint) {
			this._startTime = DateTime.Now;			
		}

		public void endLogging(IJoinPoint aJoinpoint) {
			DateTime _endTime = DateTime.Now;			
			string message =
				"-----------------------------------\n" + 
				"Message: " + aJoinpoint.message.uri + "\n" +
				" Sender: " + aJoinpoint.sender.uri + "\n" +
				" Receiver: " + aJoinpoint.receiver.uri + "\n" + 
				" Start: " + this._startTime + " End: " + _endTime;
			writeLineToLog(message);
		}

		private static void writeLineToLog(string message)
		{
			StreamWriter file = new StreamWriter("helloWorldAspect.log", true);
			file.WriteLine(message);
			file.Close();
		}

		public bool mustCancelExecution {
			get { return false; }
		}
	}
}